<?php

/* ------------ Fields control --------------
--------------- Function with fields ----- */

function jsrmsp_con_fields() {
    ?>
    <script type="text/javascript">
        jQuery(document).ready(function($) {
            <?php
            $fields_to_hide = array(
                array('field' => '#_jsrmsp_student_father_name', 'option' => 'jsrmsp_control_f1'),
                array('field' => '#_jsrmsp_student_mother_name', 'option' => 'jsrmsp_control_f2'),
                array('field' => '#_jsrmsp_student_type', 'option' => 'jsrmsp_control_f3'),
                array('field' => '#_jsrmsp_student_birth_date', 'option' => 'jsrmsp_control_f4'),
                array('field' => '#_jsrmsp_student_gender', 'option' => 'jsrmsp_control_f5'),
                array('field' => '#_jsrmsp_student_religion', 'option' => 'jsrmsp_control_f6'),
                array('field' => '#_jsrmsp_student_roll', 'option' => 'jsrmsp_control_f7'),
                array('field' => '#_jsrmsp_student_reg', 'option' => 'jsrmsp_control_f8'),
                array('field' => '#student_total_gpa', 'option' => 'jsrmsp_control_g2'),
                array('field' => '#_jsrmsp_total_gpa', 'option' => 'jsrmsp_control_f9'),
                array('field' => '#_jsrmsp_certificate', 'option' => 'jsrmsp_control_f10'),
                array('field' => '#student_photo', 'option' => 'jsrmsp_control_f11'),
            );

            foreach ($fields_to_hide as $item) {
                if (get_option($item['option'])) {
                    echo 'jQuery("' . $item['field'] . '").parent().parent().hide();';
                }
            }

            // To prevent conflict
            echo 'jQuery("#subject_group").removeClass("hide-if-js");';

            // Hide subjects
            $totalSubjects = get_option('jsrmsp_total_subjects', true);
            for ($x = 1; $x <= $totalSubjects; $x++) {
                if (get_option('jsrmsp_control_subject_f' . $x)) {
                    echo 'jQuery("#_jsrmsp_subject_' . $x . '").parent().parent().hide();';
                }
            }

            // Hide subject group
            if (get_option('jsrmsp_control_g1')) {
                echo 'jQuery("#subject_group").hide();';
            }
            ?>
        });
    </script>
    <?php
}

function jsrmsp_fields_control() {
    jsrmsp_con_fields();
}

global $pagenow;

if (isset($_GET['post_type']) && $_GET['post_type'] == 'jsrmsp_sr') {
    if ($pagenow == 'post-new.php') {
        add_action('in_admin_footer', 'jsrmsp_fields_control');
    } elseif ($pagenow == 'post.php' && isset($_GET['action']) && $_GET['action'] == 'edit') {
        add_action('in_admin_footer', 'jsrmsp_fields_control');
    }
}
?>
