<?php

/*
jQuery validation class
*/

/* 
Writing here some javascript as inline for information field validation. Because loaded this script as external js doesn't work upon user settings. So written here.
*/

global $pagenow;

if (isset($_GET['post_type']) && $_GET['post_type'] == 'jsrmsp_sr') {
    if ($pagenow == 'post-new.php') {
        function jsrmsp_admin_val()
        {
            ?>
            <script type="text/javascript">
                jQuery(document).ready(function ($) {

                    $("#post").validate({

                        rules: {
                            post_title: "required",
                            <?php
                            $fields_to_validate = array(
                                array('field' => '_jsrmsp_student_father_name', 'option' => 'jsrmsp_required_f1', 'message' => "Please enter father's name"),
                                array('field' => '_jsrmsp_student_mother_name', 'option' => 'jsrmsp_required_f2', 'message' => "Please enter mother's name"),
                                array('field' => '_jsrmsp_student_type', 'option' => 'jsrmsp_required_f3', 'message' => "Please select student's type"),
                                array('field' => '_jsrmsp_student_birth_date', 'option' => 'jsrmsp_required_f4', 'message' => "Please enter Birth date"),
                                array('field' => '_jsrmsp_student_gender', 'option' => 'jsrmsp_required_f5', 'message' => "Please select student's gender"),
                                array('field' => '_jsrmsp_student_roll', 'option' => 'jsrmsp_required_f7', 'message' => "Please enter student's roll"),
                                array('field' => '_jsrmsp_student_reg', 'option' => 'jsrmsp_required_f8', 'message' => "Please enter student's registration no"),
                                array('field' => '_jsrmsp_total_gpa', 'option' => 'jsrmsp_required_f9', 'message' => "Please enter student's total GPA"),
                                array('field' => '_jsrmsp_certificate', 'option' => 'jsrmsp_required_f10', 'message' => "Please enter certificate"),
                                array('field' => '_jsrmsp_student_photo', 'option' => 'jsrmsp_required_f11', 'message' => "Please upload student's photo"),
                            );

                            // Add subject validation
                            $totalSubjects = get_option('jsrmsp_total_subjects', true);
                            for ($x = 1; $x <= $totalSubjects; $x++) {
                                $fields_to_validate[] = array('field' => '_jsrmsp_subject_' . $x, 'option' => 'jsrmsp_required_subject_f' . $x, 'message' => "Please enter subject $x");
                            }

                            foreach ($fields_to_validate as $field) {
                                if (get_option($field['option'])) {
                                    echo $field['field'] . ': "required",';
                                }
                            }
                            ?>
                        },

                        messages: {
                            post_title: "Please enter student's name",
                            <?php
                            foreach ($fields_to_validate as $field) {
                                echo $field['field'] . ': "' . $field['message'] . '",';
                            }
                            ?>
                        }

                    });
                });
            </script>
        <?php }

        add_action('in_admin_footer', 'jsrmsp_admin_val');
    }
}
?>
