<?php

/* Result meta add Class */

class jsrmsp_rmidb{
	
	public function addRMeta( $postId, $metakey, $metavalue ){
		
		global $wpdb;
		$post_meta_table = $wpdb->prefix."postmeta";
		
		$sql = "INSERT INTO $post_meta_table SET post_id = '".$postId."',meta_key = '".$metakey."',meta_value = '".$metavalue."'";
		$wpdb->query($sql);
	
	}
	
	public function addTerm( $postId, $termId ){
		
		global $wpdb;
		$term_table = $wpdb->prefix."term_relationships";
		
		$sql = "INSERT INTO $term_table SET object_id = '".$postId."',term_taxonomy_id = '".$termId."',term_order = '0'";
		$wpdb->query($sql);
	
	}
	
	public function getTerm( $data ){
		
		global $wpdb;
		$term_table = $wpdb->prefix."terms";
		
		$restermc = $wpdb->get_row( "SELECT term_id FROM $term_table WHERE name = '".$data."'" );
		return $restermc->term_id;
	
	}
	
	public function updateTermCount( $termId ){
		
		global $wpdb;
		$term_table = $wpdb->prefix."term_relationships";
		
		$count = $wpdb->get_var( "SELECT COUNT(*) FROM $term_table WHERE term_taxonomy_id = $termId " );
		$total = $count;
		
		$term_taxonomy = $wpdb->prefix."term_taxonomy";
		$sql = "UPDATE $term_taxonomy SET count = '".$total."' WHERE term_id = '".$termId."'";
		$wpdb->query($sql);
	
	}
}


/* Csv Import Menu */

function jsrmsp_csvImportMenu(){

	add_submenu_page( 'edit.php?post_type=jsrmsp_sr', 'Import CSV', 'Import csv', 'manage_options', 'jsrmsp_csv_import_page', 'jsrmsp_csvImportAdminPage' );

}

add_action('admin_menu','jsrmsp_csvImportMenu');

function jsrmsp_csvImportAdminPage() { ?>
	
	<div class="wrap">
		<!-- Some inline style -->
		<style type="text/css">
			.jsrmsp-m-title {
			  margin: 0 !important;
			  padding: 8px 12px !important;
			}
		</style>
		<div style="display: none;" id="jsrmsp-imload" class="updated fade">

			<p><img style="height: 15px; vertical-align: middle;" src="<?php echo plugin_dir_url(__FILE__); ?>../assets/images/loader.gif" alt="" /> Importing Results...Please wait...</p>

		</div>
		
	</div><!-- end wrap -->
	
	<div class="wrap">
		<h2><?php _e('Import CSV'); ?></h2>
		<!-- Ajax Response Message -->
		<div class="ajax-response-message"></div>
		
		<div id="dashboard-widgets-wrap">
			<div class="metabox-holder" id="dashboard-widgets">
				<div id="postbox-container" class="postbox-container">
					<div id="side-sortables" class="meta-box-sortables ui-sortable"><div style="display: block;" id="dashboard_quick_press" class="postbox ">
					<h3 class="hndle jsrmsp-m-title" style="cursor: default;"><span><span class="hide-if-no-js">Upload Csv File</span></span></h3>
					<div style="overflow: hidden;" class="inside">

						<form action="" method="post" id="jsrmsp-import" class="jsrmsp-import">

							<div style="margin: 10px 0;" class="input-text-wrap">
								<span style="font-size: 15px; margin-right: 5px;"><label for="result-status">Result will be</label></span>
								<select id="result-status" name="jsrmsp_rstatus" class="" required>	
									<option selected="selected" value="">Select</option>
									<option value="draft">Drafted</option>
									<option value="publish">Published</option>
								</select>
							</div>
						
							<div class="input-text-wrap">
								<input type="text" name="jsrmsp_csv_file" id="jsrmsp-csv-file" placeholder="Upload or paste direct url of .csv file" class="jsrmsp-csv-upload" id="jsrmsp_csv_file" required />
							</div>
							
							<div style="margin: 10px 0;" class="input-text-wrap">
								<button style="float: right;" class="jsrmsp_csv_upload button">Upload</button>
							</div>

							<p class="submit">
								<?php submit_button('Import'); ?>
							</p>
							
						</form>
					</div>
					</div>
					</div>	
				</div>
			</div>
		</div>
	</div>
	
<?php }

/* Ajax result import function */

function jsrmsp_ajaxResultImport(){
	
	$rmadd = new jsrmsp_rmidb();

	/* Check form data */

	if( isset($_POST['jsrmsp_csv_file']) && isset($_POST['jsrmsp_rstatus']) ){
		
		try{
			
			if( empty($_POST['jsrmsp_rstatus']) ) {
			
				throw new Exception("Please Select result status...Drafted or Published.");
			}
			
			if( empty($_POST['jsrmsp_csv_file']) ) {
			
				throw new Exception("Please Select a file");
			}
			
			$temp = explode(".", $_POST['jsrmsp_csv_file']);
			$allowedExts = array("csv");
			$extension = end($temp);
			
			if( !in_array($extension, $allowedExts)){

				throw new Exception("Please Select .CSV file");
			}

			// Result status and file link
			
			$jsrmsp_csv_file = $_POST['jsrmsp_csv_file'];
			$jsrmsp_rstatus = $_POST['jsrmsp_rstatus'];
			
			/* Copy to a temp path for importing */
			
			$csv_url  = $jsrmsp_csv_file;
			$get_csv_path = explode(get_site_url().'/wp-content/uploads/', $csv_url);

			$upload_dir = wp_upload_dir();
			$csv_file = $upload_dir['basedir'].'/'.$get_csv_path[1];
			
			//$csv_file = plugin_dir_path( __FILE__ )."temp_csv/results.csv";

			// $ch = curl_init($csv_url);
			
			// /* Below three line for https url */
			
			// curl_setopt($ch, CURLOPT_VERBOSE, true);
			// curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			// curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

			// curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

			// $csv_data = curl_exec($ch);

			// curl_close($ch);

			// if(file_put_contents($csv_file, $csv_data)){
			// 	// Success
			// }
			// else{
			// 	// Failed
			// }
			
			global $wpdb;
			$post_table = $wpdb->prefix."posts";
			$post_meta_table = $wpdb->prefix."postmeta";
			$term_table = $wpdb->prefix."terms";
			$handle = fopen($csv_file, 'r');

			$totalSubjects = get_option('jsrmsp_total_subjects', true);

			$i = 0;
			while(($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
				if($i == 0){
					/* Post information  */
					
					$post_title = "post_title";
					$post_date = "post_date";
					$post_date_gmt = "post_date_gmt";
					$post_type = "post_type";
					$post_status = "post_status";
					
					/* Get mysql date and time */
					
					$vaild_date = current_time('mysql');
					$mm = substr( $vaild_date, 5, 2 );
					$jj = substr( $vaild_date, 8, 2 );
					$aa = substr( $vaild_date, 0, 4 );
					
					$get_post_date = wp_checkdate( $mm, $jj, $aa, $vaild_date );
					$get_post_date_gmt = get_gmt_from_date($vaild_date);
					
					/* Post meta information */
					
					$post_id = "post_id";
					$meta_key = "meta_key";
					$meta_value = "meta_value";
					
					/* Student's information */
					
					$father_name = "_jsrmsp_student_father_name";
					$mother_name = "_jsrmsp_student_mother_name";
					$student_type = "_jsrmsp_student_type";
					$student_birthdate = "_jsrmsp_student_birth_date";
					$student_gender = "_jsrmsp_student_gender";
					$student_religion = "_jsrmsp_student_religion";
					$student_roll = "_jsrmsp_student_roll";
					$student_reg = "_jsrmsp_student_reg";
					$student_gpa = "_jsrmsp_total_gpa";
					$student_photo = "_jsrmsp_student_photo";
					$student_cer = "_jsrmsp_certificate";
						
				}
				
				if($i>0){
					
					/* Insert Result */
					
					if( !empty( $data[0] ) ){
						
						/* Generate result link */
					
						$name = $data[0];
						$name2 = strtolower( $name );
						$link = str_replace( ' ', '-', $name2 );
						
						$sql = "INSERT INTO $post_table SET $post_title = '".$data[0]."',$post_date = '".$vaild_date."',$post_date_gmt = '".$get_post_date_gmt."',$post_status = '".$jsrmsp_rstatus."',$post_type = 'jsrmsp_sr',comment_status = 'closed',ping_status = 'closed',post_name = '".$link."'";
						$wpdb->query($sql);
					}
					
				}
				
				if($i>0){
				
					/* Insert Result taxomony */
					
					$lastri = $wpdb->get_row( "SELECT * FROM $post_table ORDER BY ID DESC LIMIT 1" );
					
					$lastriv = $lastri->ID;
					
					/* Insert Class */
					$classId = $rmadd->getTerm( $data[9] );
					if( !empty( $classId ) ){
						$rmadd->addTerm( $lastriv, $classId );
						$rmadd->updateTermCount( $classId );
					}
					/* Insert Year */
					$classId = $rmadd->getTerm( $data[10] );
					if( !empty( $classId ) ){
						$rmadd->addTerm( $lastriv, $classId );
						$rmadd->updateTermCount( $classId );
					}
					/* Insert Section */
					$classId = $rmadd->getTerm( $data[11] );
					if( !empty( $classId ) ){
						$rmadd->addTerm( $lastriv, $classId );
						$rmadd->updateTermCount( $classId );
					}
					/* Insert Group */
					$classId = $rmadd->getTerm( $data[12] );
					if( !empty( $classId ) ){
						$rmadd->addTerm( $lastriv, $classId );
						$rmadd->updateTermCount( $classId );
					}
				
				}
				
				if($i>0){
					
					//Inserting result meta
					
					$lastri = $wpdb->get_row( "SELECT * FROM $post_table ORDER BY ID DESC LIMIT 1" );
					
					$lastriv = $lastri->ID;
					
					/* Result meta 1 */
					if( !empty( $data[1] ) ){
						$rmadd->addRMeta( $lastriv, $father_name, $data[1] );
					}
					/* Result meta 2 */
					if( !empty( $data[2] ) ){
						$rmadd->addRMeta( $lastriv, $mother_name, $data[2] );
					}
					/* Result meta 3 */
					if( !empty( $data[3] ) ){
						$rmadd->addRMeta( $lastriv, $student_type, $data[3] );
					}
					/* Result meta 4 */
					if( !empty( $data[4] ) ){
						$rmadd->addRMeta( $lastriv, $student_birthdate, $data[4] );
					}
					/* Result meta 5 */
					if( !empty( $data[5] ) ){
						$rmadd->addRMeta( $lastriv, $student_gender, $data[5] );
					}
					/* Result meta 6 */
					if( !empty( $data[6] ) ){
						$rmadd->addRMeta( $lastriv, $student_religion, $data[6] );
					}
					/* Result meta 7 */
					if( !empty( $data[7] ) ){
						$rmadd->addRMeta( $lastriv, $student_roll, $data[7] );
					}
					/* Result meta 8 */
					if( !empty( $data[8] ) ){
						$rmadd->addRMeta( $lastriv, $student_reg, $data[8] );
					}
					/* Result meta 9 */
					if( !empty( $data[13] ) ){
						$rmadd->addRMeta( $lastriv, $student_gpa, $data[13] );
					}
					/* Result meta 10 */
					if( !empty( $data[14] ) ){
						$rmadd->addRMeta( $lastriv, $student_photo, $data[14] );
					}
					/* Result meta 11 */
					if( !empty( $data[14] ) ){
						$rmadd->addRMeta( $lastriv, $student_cer, $data[15] );
					}

					/* Insert subject's value */
					
					$csvDataCounter = 15;

					for ($x = 1; $x <= $totalSubjects; $x++){
						$csvDataCounter++;
				
						if( !empty( $data[$csvDataCounter] ) ){
							$rmadd->addRMeta( $lastriv, "_jsrmsp_subject_".$x, $data[$csvDataCounter] );
						}
					}
					
				}
				
				$i++;
			}
			
			/* Count all inserted results */
			if($i > 0){
				$result_inserted = $i - 1;
				$success = "$result_inserted Results imported and $jsrmsp_rstatus successfully";
				fclose($handle);
				//unlink($csv_file);
			} else{
				throw new Exception("There is a problem with parsing the csv file");
			}
			
		}
		
		catch(Exception $e){
		
			$error = $e->getMessage();
		
		}

	}
	
	?>
		
	<!-- Error Message -->
	<?php if( isset( $error ) ): ?>
	<div class="error">
		<p><?php echo $error; ?></p>
	</div>
	<?php endif; ?>
	
	<!-- Success Message -->
	<?php if( isset( $success ) ): ?>
	<div class="updated fade">
		<p><?php echo $success; ?></p>
	</div>
	<?php endif; ?>
	<?php
	
	die();
	
}

add_action('wp_ajax_jsrmsp_ari','jsrmsp_ajaxResultImport');
add_action('wp_ajax_nopriv_jsrmsp_ari','jsrmsp_ajaxResultImport');

function jsrmsp_csv_import_script() {
	// This will enqueue the Media Uploader script
	wp_enqueue_media();
}

add_action('admin_enqueue_scripts','jsrmsp_csv_import_script');