
// Get data object 

var jseacgpD = jseacgpData;
var pluginDir = jseacgpD.pluginPath;

(function($){
"use strict";
	$(document).ready(function(){
	
		/* 
		* Import result form csv file
		*/

		/* Default Upload modal */
		$('.jsrmsp_csv_upload').on('click', function(e) {
			e.preventDefault();
			var image = wp.media({ 
				title: 'Upload CSV',
				// mutiple: true if you want to upload multiple files at once
				multiple: false
			}).open()
			.on('select', function(e){
				// This will return the selected image from the Media Uploader, the result is an object
				var uploaded_image = image.state().get('selection').first();
				// We convert uploaded_image to a JSON object to make accessing it easier
				// Output to the console uploaded_image
				console.log(uploaded_image);
				var image_url = uploaded_image.toJSON().url;
				// Let's assign the url value to the input field
				$('.jsrmsp-csv-upload').val(image_url);
			});
		});
		
		/* Main job */
		$('form#jsrmsp-import').on('submit', function(e){
			//Execute when submit
			e.preventDefault();
			
			//Add necessary veritable
			
			var jsrmsp_rstatus = $('#result-status').val();
			var jsrmsp_csv_file = $('#jsrmsp-csv-file').val();
			
			//Add Jquery ajax method
			
			$.ajax({
				type: 'POST',
				url:  jseacgpD.ajaxUrl,
				data: {
					action: 'jsrmsp_ari',
					jsrmsp_rstatus: jsrmsp_rstatus,
					jsrmsp_csv_file: jsrmsp_csv_file
				},
				success: function(data){
					$('.ajax-response-message').html( data );
				},
				error: function(XMLHttpRequest, textStatus, errorTown){
					alert(errorTown);
				},
				beforeSend: function(){
					$('#jsrmsp-imload').show()
				},
				complete: function(){
					$('#jsrmsp-imload').hide();
				}
	  
			});
		}); // End form submit

		/**
		* Show different search form when change dropdown option from settings panel
		*/

		$("#s_form_l").on('change', function(){

		  if(this.value == 'default'){
			  $('body').append('<div class="overly" style="position: fixed; width: 100%; height: 100%; opacity: 0.5; background: rgb(51, 51, 51) none repeat scroll 0px 0px; top: 0px; left: 0px; z-index: 19999;"></div></div><div class="centered" style="background-color: rgb(238, 238, 238); position: fixed; width: 40%; text-align: center; top: 15%; left: 50%; padding: 20px 0px 0px; transform: translate(-50%, 0px); z-index: 19999;"><img style="max-width: 100%; margin-bottom: 20px;" src="'+pluginDir+'default.png" alt="" /><div id="close" style="padding: 10px 2px; font-weight: bold; cursor: pointer; background: rgb(82, 82, 82) none repeat scroll 0% 0%; color: rgb(221, 221, 221);">Close</div></div>');
			  
			  $('div#close').on('click', function(){
					$(this).parent().remove();
					$('div.overly').remove();
			  });
		  }
		  
		  if(this.value == 'roll'){
			  $('body').append('<div class="overly" style="position: fixed; width: 100%; height: 100%; opacity: 0.5; background: rgb(51, 51, 51) none repeat scroll 0px 0px; top: 0px; left: 0px; z-index: 19999;"></div></div><div class="centered" style="background-color: rgb(238, 238, 238); position: fixed; width: 40%; text-align: center; top: 15%; left: 50%; padding: 20px 0px 0px; transform: translate(-50%, 0px); z-index: 19999;"><img style="max-width: 100%; margin-bottom: 20px;" src="'+pluginDir+'roll.png" alt="" /><div id="close" style="padding: 10px 2px; font-weight: bold; cursor: pointer; background: rgb(82, 82, 82) none repeat scroll 0% 0%; color: rgb(221, 221, 221);">Close</div></div>');
			  
			  $('div#close').on('click', function(){
					$(this).parent().remove();
					$('div.overly').remove();
			  });
		  }
		  
		  if(this.value == 'all'){
			  $('body').append('<div class="overly" style="position: fixed; width: 100%; height: 100%; opacity: 0.5; background: rgb(51, 51, 51) none repeat scroll 0px 0px; top: 0px; left: 0px; z-index: 19999;"></div></div><div class="centered" style="background-color: rgb(238, 238, 238); position: fixed; width: 40%; text-align: center; top: 15%; left: 50%; padding: 20px 0px 0px; transform: translate(-50%, 0px); z-index: 19999;"><img style="max-width: 100%; margin-bottom: 20px;" src="'+pluginDir+'all.png" alt="" /><div id="close" style="padding: 10px 2px; font-weight: bold; cursor: pointer; background: rgb(82, 82, 82) none repeat scroll 0% 0%; color: rgb(221, 221, 221);">Close</div></div>');
			  
			  $('div#close').on('click', function(){
					$(this).parent().remove();
					$('div.overly').remove();
			  });
		  }

		  if(this.value == 'exrollnreg'){
			  $('body').append('<div class="overly" style="position: fixed; width: 100%; height: 100%; opacity: 0.5; background: rgb(51, 51, 51) none repeat scroll 0px 0px; top: 0px; left: 0px; z-index: 19999;"></div></div><div class="centered" style="background-color: rgb(238, 238, 238); position: fixed; width: 40%; text-align: center; top: 15%; left: 50%; padding: 20px 0px 0px; transform: translate(-50%, 0px); z-index: 19999;"><img style="max-width: 100%; margin-bottom: 20px;" src="'+pluginDir+'examRollReg.png" alt="" /><div id="close" style="padding: 10px 2px; font-weight: bold; cursor: pointer; background: rgb(82, 82, 82) none repeat scroll 0% 0%; color: rgb(221, 221, 221);">Close</div></div>');
			  
			  $('div#close').on('click', function(){
					$(this).parent().remove();
					$('div.overly').remove();
			  });
		  }

		  if(this.value == 'rollnreg'){
			  $('body').append('<div class="overly" style="position: fixed; width: 100%; height: 100%; opacity: 0.5; background: rgb(51, 51, 51) none repeat scroll 0px 0px; top: 0px; left: 0px; z-index: 19999;"></div></div><div class="centered" style="background-color: rgb(238, 238, 238); position: fixed; width: 40%; text-align: center; top: 15%; left: 50%; padding: 20px 0px 0px; transform: translate(-50%, 0px); z-index: 19999;"><img style="max-width: 100%; margin-bottom: 20px;" src="'+pluginDir+'rollnreg.png" alt="" /><div id="close" style="padding: 10px 2px; font-weight: bold; cursor: pointer; background: rgb(82, 82, 82) none repeat scroll 0% 0%; color: rgb(221, 221, 221);">Close</div></div>');
			  
			  $('div#close').on('click', function(){
					$(this).parent().remove();
					$('div.overly').remove();
			  });
		  }

		  if(this.value == 'reg'){
			  $('body').append('<div class="overly" style="position: fixed; width: 100%; height: 100%; opacity: 0.5; background: rgb(51, 51, 51) none repeat scroll 0px 0px; top: 0px; left: 0px; z-index: 19999;"></div></div><div class="centered" style="background-color: rgb(238, 238, 238); position: fixed; width: 40%; text-align: center; top: 15%; left: 50%; padding: 20px 0px 0px; transform: translate(-50%, 0px); z-index: 19999;"><img style="max-width: 100%; margin-bottom: 20px;" src="'+pluginDir+'reg.png" alt="" /><div id="close" style="padding: 10px 2px; font-weight: bold; cursor: pointer; background: rgb(82, 82, 82) none repeat scroll 0% 0%; color: rgb(221, 221, 221);">Close</div></div>');
			  
			  $('div#close').on('click', function(){
					$(this).parent().remove();
					$('div.overly').remove();
			  });
		  }

		  if(this.value == 'namenbirth'){
			  $('body').append('<div class="overly" style="position: fixed; width: 100%; height: 100%; opacity: 0.5; background: rgb(51, 51, 51) none repeat scroll 0px 0px; top: 0px; left: 0px; z-index: 19999;"></div></div><div class="centered" style="background-color: rgb(238, 238, 238); position: fixed; width: 40%; text-align: center; top: 15%; left: 50%; padding: 20px 0px 0px; transform: translate(-50%, 0px); z-index: 19999;"><img style="max-width: 100%; margin-bottom: 20px;" src="'+pluginDir+'namenbirth.png" alt="" /><div id="close" style="padding: 10px 2px; font-weight: bold; cursor: pointer; background: rgb(82, 82, 82) none repeat scroll 0% 0%; color: rgb(221, 221, 221);">Close</div></div>');
			  
			  $('div#close').on('click', function(){
					$(this).parent().remove();
					$('div.overly').remove();
			  });
		  }

		  if(this.value == 'regnbirth'){
			  $('body').append('<div class="overly" style="position: fixed; width: 100%; height: 100%; opacity: 0.5; background: rgb(51, 51, 51) none repeat scroll 0px 0px; top: 0px; left: 0px; z-index: 19999;"></div></div><div class="centered" style="background-color: rgb(238, 238, 238); position: fixed; width: 40%; text-align: center; top: 15%; left: 50%; padding: 20px 0px 0px; transform: translate(-50%, 0px); z-index: 19999;"><img style="max-width: 100%; margin-bottom: 20px;" src="'+pluginDir+'regnbirth.png" alt="" /><div id="close" style="padding: 10px 2px; font-weight: bold; cursor: pointer; background: rgb(82, 82, 82) none repeat scroll 0% 0%; color: rgb(221, 221, 221);">Close</div></div>');
			  
			  $('div#close').on('click', function(){
					$(this).parent().remove();
					$('div.overly').remove();
			  });
		  } 
		  
		}); // End onchange event
		
	});
})(jQuery);