<?php 

/*
	Class: Get post meta
*/

class jsrmsp_result_meta{
	
	/* Result info function */
	
	public function result_meta( $meta_id, $field_id ){ ?>
		<?php 
			$meta_name = get_post_meta( get_the_ID(),$meta_id,true );
			if($meta_name):
		?>
		
		<td><span class="jsrmsp-label"><?php echo get_option($field_id); ?></span></td>
		<td><span class="jsrmsp-info"><?php echo $meta_name; ?></span></td>
		<?php else: ?>
		<td></td>
		<td></td>
		<?php endif; ?>
	<?php }

public function result_meta_marksheet( $meta_id, $field_id ){ ?>
	<?php 
		$meta_name = get_post_meta( get_the_ID(),$meta_id,true );
		if($meta_name):
	?>
	<tr>
		<td><span class="jsrmsp-label"><?php echo get_option($field_id); ?></span></td>
		<td><span class="jsrmsp-info"><?php echo $meta_name; ?></span></td>
	</tr>
	<?php endif; ?>
<?php }
	
	public function result_meta_check( $meta_id){ ?>
		<?php 
			$meta_name = get_post_meta( get_the_ID(),$meta_id,true );
			if($meta_name){
				return true;
			}
	}
	
	/* Date of brith function */
	
	public function date_of_birth( $meta_id, $field_id ){ ?>
		<?php 
			$meta_name = get_post_meta( get_the_ID(),$meta_id,true );
			if($meta_name):
		?>
		
		<td><span class="jsrmsp-label"><?php echo get_option($field_id); ?></span></td>
		<td>
			<span class="jsrmsp-info">
				<?php 
					$meta_name; 
					$convert_date = explode("/",$meta_name);
					echo $convert_date[0];
					if($convert_date[1] == 1){
						echo " January ";
					}
					if($convert_date[1] == 2){
						echo " February ";
					}
					if($convert_date[1] == 3){
						echo " March ";
					}
					if($convert_date[1] == 4){
						echo " April ";
					}
					if($convert_date[1] == 5){
						echo " May ";
					}
					if($convert_date[1] == 6){
						echo " June ";
					}
					if($convert_date[1] == 7){
						echo " July ";
					}
					if($convert_date[1] == 8){
						echo " August ";
					}
					if($convert_date[1] == 9){
						echo " September ";
					}
					if($convert_date[1] == 10){
						echo " October ";
					}
					if($convert_date[1] == 11){
						echo " November ";
					}
					if($convert_date[1] == 12){
						echo " December ";
					}
					echo $convert_date[2];
				?>
			</span>
		</td>
		<?php else: ?>
		<td></td>
		<td></td>
		<?php endif; ?>
	<?php }
	
	/* Institiute info function */
	
	public function ins_name( $field_id ){ ?>
		<?php 
			$field_id = get_option($field_id);
			if($field_id):
		?>
		<td><span class="jsrmsp-label"><?php _e('Institute','jsrmsp-td'); ?></span></td>
		<td><span class="jsrmsp-info"><?php echo $field_id; ?></span></td>
		<?php else: ?>
		<td></td>
		<td></td>
		<?php endif; ?>
	<?php }
	
	/* Group info function */
	
	public function group_name(){ ?>
		<?php 
			$group = get_the_term_list( get_the_ID(), 'groups', '', ', ', '' );
			$group = strip_tags($group);
			if( get_the_term_list( get_the_ID(), 'groups' ) != null ):
		?>
		<td><span class="jsrmsp-label"><?php echo get_option('jsrmsp_egroup'); ?></span></td>
		<td><span class="jsrmsp-info"><?php echo $group; ?></span></td>
		<?php else: ?>
		<td></td>
		<td></td>
		<?php endif; ?>
	<?php }
	
	/* Section info function */
	
	public function section_name(){ ?>
		<?php 
			$section = get_the_term_list( get_the_ID(), 'sections', '', ', ', '' );
			$section = strip_tags($section);
			if( get_the_term_list( get_the_ID(), 'sections' ) != null ):
		?>
		
		<td><span class="jsrmsp-label"><?php echo get_option('jsrmsp_esection'); ?></span></td>
		<td><span class="jsrmsp-info"><?php echo $section; ?></span></td>
		
		<?php else: ?>
		<td></td>
		<td></td>
		
		<?php endif; ?>
	<?php }
	
	/* Class sl info function */
	
	public function class_name_sl(){ 
		$class = get_the_term_list( get_the_ID(), 'classes', '', ', ', '' );
		$class = strip_tags($class);
		if( get_the_term_list( get_the_ID(), 'classes' ) != null ){
			echo $class;
	
		}
	}
	
	/* Year sl info function */
	
	public function year_name_sl(){ 
		$years = get_the_term_list( get_the_ID(), 'years', '', ', ', '' );
		$years = strip_tags($years);
		if( get_the_term_list( get_the_ID(), 'years' ) != null ){
			echo $years;
	
		}
	}
	
	/* Another info function */
	
	public function another_sub( $meta_id ){ ?>
		<?php
			$another_subjects_check = get_post_meta( get_the_ID(),$meta_id,true );
			if($another_subjects_check): ?>
		<?php
			$another_subjects = get_post_meta( get_the_ID(),$meta_id,true );
			foreach($another_subjects as $another_subject): 
		?>
		<tr>
			<td><span class="jsrmsp-label"><?php echo $another_subject['another_subject_name']; ?></span></td>
			<td><span class="jsrmsp-info"><?php echo $another_subject['another_subject_grad']; ?></span></td>
		</tr>
		<?php
			endforeach; 
			endif;
		?>
	<?php }
	
	/* Certificate info function */
	
	public function certificate( $meta_id ){ ?>
		<?php 
			$certificate = get_post_meta( get_the_ID(),$meta_id,true );
			if($certificate):
		?>
		<tr class="jsrmsp-certificate-view">
			<td><span class="jsrmsp-certificate-label"><?php if(get_option( 'jsrmsp_certificateRow' )){ echo get_option( 'jsrmsp_certificateRow' ); } else{ _e( 'Certificate', 'jsrmsp-td' ); } ?></span></td>
			<td><span class="jsrmsp-certificate-info"><a class="fancybox" href="<?php echo $certificate; ?>" title="<?php if(get_option( 'jsrmsp_certificateRow' )){ echo 'View '.get_option( 'jsrmsp_certificateRow' ); } else{ _e( 'View Certificate', 'jsrmsp-td' ); } ?>"><img src="<?php echo plugin_dir_url(__FILE__)."../images/view.png"; ?>" alt="" /></a> <a href="?file=<?php echo $certificate; ?>&id=<?php echo the_ID(); ?>" target="_blank" title="<?php if(get_option( 'jsrmsp_certificateRow' )){ echo 'Download '.get_option( 'jsrmsp_certificateRow' ); } else{ _e( 'Download Certificate', 'jsrmsp-td' ); } ?>"><img src="<?php echo plugin_dir_url(__FILE__)."../images/download.png"; ?>" alt="" /></a></span></td>
		</tr>
		<?php endif; ?>
	<?php }

	public function studentPhoto(){ 
		$photo = get_post_meta( get_the_ID(), '_jsrmsp_student_photo',true );
		if($photo){ ?>
			<div class="jsrmsp-student-photo">
					<img src="<?php echo $photo; ?>" alt="">
					<div style="clear: both;"></div>
				</div>
		<?php }
	}

	public function examControllerSignature(){ 
		$controllerSignature = get_option('jsrmsp_examControllerSignature');
		$examControllerName = get_option('jsrmsp_examControllerName', true);
		$isShowThisSection = get_option('jsrmsp_showQrcodeSignatureSection');
		$examControllerDest = get_option('jsrmsp_controllerOfExam', true);
		$institueName = get_option('jsrmsp_school_name', true);
		if($isShowThisSection){ ?>
			<div class="jsrmsp-exam-controller-area">
				<div class="jsrmsp-exam-controller-left">
					<img src="https://api.qrserver.com/v1/create-qr-code/?data=<?php echo get_the_permalink(); ?>&amp;size=110x110" alt="" title="" />
				</div>
				<div class="jsrmsp-exam-controller-right">
					<img src="<?php echo wp_get_attachment_url($controllerSignature); ?>" alt="Signature" class="jsrmsp-exam-controller-signature">
					<h4 class="jsrmsp-exam-controller-name"><?php echo $examControllerName; ?></h4>
					<h4 class="jsrmsp-exam-controller-dest"><?php echo $examControllerDest; ?></h4>
					<h3 class="jsrmsp-institute-name"><?php echo $institueName; ?></h3>
				</div>
			</div>
		<?php }
	}

	public function watermarkImage(){
		$image = get_option('jsrmsp_watermarkImage'); 
		if($image) { ?> 
			<div class="jsrmsp-watermark">
				<img src="<?php echo wp_get_attachment_url($image) ?>" alt="">
			</div>
		<?php }
	}

	/* Certificate info shortcode embed form */

	public function certificateShortcode( $meta_id ){ ?>
		<?php 
			$certificate = get_post_meta( get_the_ID(),$meta_id,true );
			if($certificate):
		?>
		<tr class="jsrmsp-certificate-view">
			<td><span class="jsrmsp-certificate-label"><?php if(get_option( 'jsrmsp_certificateRow' )){ echo get_option( 'jsrmsp_certificateRow' ); } else{ _e( 'Certificate', 'jsrmsp-td' ); } ?></span></td>
			<td><span class="jsrmsp-certificate-info"><a style="text-decoration: none;" class="fancybox" href="<?php echo $certificate; ?>" title="<?php if(get_option( 'jsrmsp_certificateRow' )){ echo 'View '.get_option( 'jsrmsp_certificateRow' ); } else{ _e( 'View Certificate', 'jsrmsp-td' ); } ?>"><img style="display: inline-block;height: 20px; width: 20px; vertical-align: inherit;" src="<?php echo plugin_dir_url(__FILE__)."../images/view.png"; ?>" alt="" /></a> <a style="text-decoration: none;" href="<?php echo admin_url(); ?>/admin-ajax.php?action=jsrmspCDl&file=<?php echo $certificate; ?>&id=<?php echo the_ID(); ?>" target="_blank" title="<?php if(get_option( 'jsrmsp_certificateRow' )){ echo 'Download '.get_option( 'jsrmsp_certificateRow' ); } else{ _e( 'Download Certificate', 'jsrmsp-td' ); } ?>"><img style="display: inline-block;height: 20px; width: 20px; vertical-align: inherit;" src="<?php echo plugin_dir_url(__FILE__)."../images/download.png"; ?>" alt="" /></a></span></td>
		</tr>
		<?php endif; ?>
	<?php }

	
	//Certificate info for android app
	
	public function certificateApp( $meta_id ){ ?>
		<?php 
			$certificate = get_post_meta( get_the_ID(),$meta_id,true );
			if($certificate):
		?>
		<tr class="jsrmsp-certificate-view">
			<td><span class="jsrmsp-certificate-label"><?php echo get_option('jsrmsp_certificateRow'); ?></span></td>
			<td><span class="jsrmsp-certificate-info"><a id="view-certificate" class="showCertificate" data-popup=".certificate-popup" data-url="<?php echo $certificate; ?>" href="#">View</a> <a href="<?php echo $certificate; ?>" class="external">Download</a></span></td>
		</tr>
		<?php endif; ?>
	<?php }
	
	//Certificate download frp
	public function cerTDlmain($file_url, $file_id){
		// Get file ext
		$fileName = $file_url;
		$file_ex = explode(".",$fileName);
		$arrayL = count(explode(".",$fileName));
		$last_ele = $arrayL - 1;
		$fileEx = $file_ex[$arrayL-1];
		$new_file = plugin_dir_path( __FILE__ )."../temp_img/".$file_id.".".$fileEx;
		$ch = curl_init($file_url);
		
		/* Below three line for https url */
		curl_setopt($ch, CURLOPT_VERBOSE, true);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$file_content = curl_exec($ch);

		curl_close($ch);

		if(file_put_contents($new_file, $file_content)){
			return array($new_file,$fileEx);
		}
		else{
			// Failed
		}
	}

	// Methods for app
	public function result_meta_app( $meta_id, $field_id ){ 

		$meta_name = get_post_meta( get_the_ID(),$meta_id,true );
		
		if($meta_name){
			return array(
				"key" => get_option($field_id),
				"value" => $meta_name
			);
		}

		return array(
			"key" => null,
			"value" => null
		);
	}

	public function resul_student_photo_app( $meta_id ){ 

		$meta_name = get_post_meta( get_the_ID(),$meta_id,true );
		
		if($meta_name){
			return array(
				"value" => $meta_name
			);
		}

		return array(
			"value" => null
		);
	}

	public function group_name_app(){
		$group = get_the_term_list( get_the_ID(), 'groups', '', ', ', '' );
		$group = strip_tags($group);
		
		if( get_the_term_list( get_the_ID(), 'groups' ) != null ){
			return array(
				"key" => get_option('jsrmsp_egroup'),
				"value" => $group
			);
		}

		return array(
			"key" => null,
			"value" => null
		);
	 }
	
	public function section_name_app(){ 
		$section = get_the_term_list( get_the_ID(), 'sections', '', ', ', '' );
		$section = strip_tags($section);

		if( get_the_term_list( get_the_ID(), 'sections' ) != null ){
			return array(
				"key" => get_option('jsrmsp_esection'),
				"value" => $section
			);
		}

		return array(
			"key" => null,
			"value" => null
		);
	}

	public function year_name_only_app(){
		$year = get_the_term_list( get_the_ID(), 'years', '', ', ', '' );
		$year = strip_tags($year);
		
		if( get_the_term_list( get_the_ID(), 'years' ) != null ){
			return $year;
		}

		return null;
		
	}

	public function class_name_only_app(){
		$class = get_the_term_list( get_the_ID(), 'classes', '', ', ', '' );
		$class = strip_tags($class);
		
		if( get_the_term_list( get_the_ID(), 'classes' ) != null ){
			return $class;
		}

		return null;
	}

	public function ins_name_app( $field_id ){
		$field_id = get_option($field_id);

		if($field_id){
			return array(
				'key' => 'Institute',
				'value' => $field_id
			);
		}

		return array(
			"key" => null,
			"value" => null
		);
	}


	public function certificate_app( $meta_id ){ 
		$certificate = get_post_meta( get_the_ID(),$meta_id,true );
		
		if($certificate){
			return array(
				'key' => get_option('jsrmsp_certificateRow'),
				'value' => $certificate
			);
		}

		return array(
			"key" => null,
			"value" => null
		);
	}
}	
	
?>